<template>
    <div class="context">
        <div class="panel">
            <h5>教练管理</h5>
            <div class="panel-body">
                <div class="panel_control">
                    <el-row :gutter="20">
                        <el-col :span="4">
                            <em>姓名:</em>
                            <el-input v-model="panel.USERCODE" placeholder="请输入姓名"></el-input>
                        </el-col>
                        <el-col :span="4">
                            <em>手机号:</em>
                            <el-input v-model="panel.keyword" placeholder="请输入手机号"></el-input>
                        </el-col>
                        <el-col :span="4">
                            <el-button size="" type="primary" @click="query" plain>查询</el-button>
                        </el-col>
                    </el-row>
                </div>
            </div>
        </div>
        <div class="change">
            <el-button @click="addMember" type="primary">新增教练</el-button>
            <el-button @click="delList">删除教练</el-button>
        </div>
        <div class="table">
            <el-table
                    :data="tableData"
                    border
                    is-horizontal-resize
                    :default-sort="{prop: 'date', order: 'descending'}"
                    element-loading-background="rgba(0, 0, 0, 0.8)"
                    class=""
                    @selection-change="handleSelectionChange"
            >
                <el-table-column
                        type="selection"
                        width="55">
                </el-table-column>
                <el-table-column
                        type="index"
                        label="序号"
                        width="50">
                </el-table-column>
                <el-table-column
                        prop="name"
                        label="教练"
                >
                </el-table-column>
                <el-table-column
                        prop="tel"
                        label="手机号"
                        sortable
                >
                </el-table-column>
                <el-table-column
                        prop="Recovered"
                        label="上课总时长（h）"
                        width="180"
                        sortable
                >
                </el-table-column>
                <el-table-column
                        prop="Status"
                        label="操作"
                >
                    <template slot-scope="scope">
                        <el-button type="text" @click="editMember(scope.row)">编辑</el-button>
                    </template>
                </el-table-column>
            </el-table>
            <br>
            <el-pagination
                    background
                    :total="pageination.total"
                    :page-size="pageination.pageItem"
                    @current-change="pageChange"
            ></el-pagination>
        </div>

        <el-dialog :title="dialogTitle" :visible.sync="dialogMemberVisible" width="480px">
            <div class="dialogContent">
                <div class="">
                    <el-form ref="form" :model="form" label-width="160px">
                        <el-form-item label="手机号">
                            <el-input v-model="form.userCode"></el-input>
                        </el-form-item>
                        <el-form-item label="姓名">
                            <el-input v-model="form.name"></el-input>
                        </el-form-item>
<!--                        <el-form-item label="课时">-->
<!--                            <el-input-number v-model="form.lesson" :min="0" :max="99999" label="（天）"></el-input-number>-->
<!--                        </el-form-item>-->
                    </el-form>
                </div>
            </div>
            <div class="dialogFooter">
                <el-button type="primary" size="small" v-if="form.btnType == 0" @click="confirmMember">确定</el-button>
                <el-button type="primary" size="small"  v-if="form.btnType == 1" @click="confirmEditMember">确定</el-button>
                <el-button size="small" @click="dialogMemberVisible = false">取消</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
    import Global from '../Global.js'
    import {
        testTable,
        testSelect
    } from "../api/getApiRes";

    let qs = require('qs');
    export default {
        data() {
            return {
                dialogVisible: false,//其他dialog
                dialogMemberVisible: false,//新增教练dialog
                dialogLesson: false,//课时调整
                dialogGift: false,//赠送课时调整
                dialogExpTime: false,//有效期调整
                dialogLessonTable: false,//教练课程
                dialogTitle: '新增教练',
                dialogValue: [],
                // panel 配置项目
                panel: {
                    usercode: '',
                    username: '',
                    compname: '',
                    keyword: '',
                    USERCODE: '',
                    endType: '',
                    taskstatus: 99,
                    draw: 1,
                    start: 0,
                    recordsTotal: 0,
                    tableData: [],
                    allTableData: [],
                    limit: '10',
                    multipleSort: false,
                    loading: false,
                    fileList: [],
                    multipleSelection: [],
                    detectedmac: '',
                    options: [
                        {value: 99, label: '全部'},
                        {value: 1, label: '进行中'},
                        {value: 2, label: '已完成'},
                    ],
                    endTypeOptions: [
                        {value: 99, label: '全部'},
                        {value: 30, label: '近一个月'},
                        {value: 7, label: '近一周'},
                        {value: 1, label: '当日'},
                    ],
                    time1: globalBt(),
                },
                multipleSelection: [],
                pageination: {
                    pageItem: 100,
                    pageoptions: pageOptions(),
                    total: 100,
                    pageIndex: 1,
                },
                form: {
                    name: '',
                    userCode: '',
                    shopId: '',
                    memberType: 1,
                    lesson: 1,
                    gift: 1,
                    btnType: 0,//0新建，1编辑编辑
                    memo: '',
                    expTime: '',
                    dialogdata: [],//穿梭待选
                    dialogValue: [],//穿梭已选
                },
                memberTypes: [
                    {value: 1, label: '年教练'},
                    {value: 2, label: '充值教练'},
                ],
                tableData: []
            }
        },
        mounted() {
            this.panelSelect();
            this.getTableQuery();
        },
        methods: {
            // 编辑
            editMember(row) {
                let that = this;
                this.clearForm();

                this.form.userCode = row.userCode;
                this.form.name = row.name;
                this.form.memberType = row.vipType;
                this.form.lesson = row.Recovered;
                this.form.gift = row.Recovered;
                this.form.memo = row.memo;
                this.form.btnType = 1;

                this.form.shopId = row.Id;
                this.dialogMemberVisible = true
                this.dialogTitle = '编辑教练'

            },
            // 禁用
            pauseRow(row) {
                let that = this;
                this.$confirm('是否禁用用户' + row.name + '？', '禁用操作', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(() => {
                    let param = {
                        token: localStorage.token,
                        Id: row.Id,
                        status: 0,
                    };
                    let postdata = qs.stringify(param);
                    testTable(postdata).then(res => {
                        let json = res;
                        if (json.Code == 0) {
                            that.$message({
                                showClose: true,
                                message: row.name + '禁用成功！',
                                type: 'success'
                            });
                            // table 重载
                            that.getTableQuery();
                        } else {
                            that.$message.error(json.Memo);
                        }
                    })
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: '已取消禁用'
                    });
                });
            },
            // 启用
            runRow(row) {
                let that = this;
                this.$confirm('是否启用用户' + row.name + '？', '启用操作', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(() => {
                    let param = {
                        token: localStorage.token,
                        Id: row.Id,
                        status: 1,
                    };
                    let postdata = qs.stringify(param);
                    testTable(postdata).then(res => {
                        let json = res;
                        if (json.Code == 0) {
                            that.$message({
                                showClose: true,
                                message: row.name + '启用成功！',
                                type: 'success'
                            });
                            // table 重载
                            that.getTableQuery();
                        } else {
                            that.$message.error(json.Memo);
                        }
                    })
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: '已取消启用'
                    });
                });
            },
            // 关闭所有
            allDialogClose() {
                this.dialogVisible = false;
                this.dialogGift = false;
                this.dialogLesson = false;
                this.dialogExpTime = false;
                this.dialogLessonTable = false;
            },
            // 用户禁用 todo
            // 用户启用 todo
            // 有效期调整
            ExpTimeChange() {
                // 仅针对年费用户，使用日期格式
                this.allDialogClose();
                if (!this.multipleSelection.length) {
                    this.$message({
                        showClose: true,
                        message: '错了哦，需要先选中至少一条记录',
                        type: 'error'
                    });
                    return false
                }
                if (this.multipleSelection.length != 1) {
                    this.$message({
                        showClose: true,
                        message: '错了哦，只能选中一条记录',
                        type: 'error'
                    });
                    return false
                }
                let row = this.multipleSelection[0];
                if (parseInt(row.vipType) == 2) {
                    this.$message({
                        showClose: true,
                        message: '错了哦，充值教练不能调整有效期',
                        type: 'error'
                    });
                    return false
                }
                this.form.expTime = row.expTime;
                this.form.rowName = row.name;
                this.dialogVisible = true;
                this.dialogExpTime = true;
            },
            // 课时调整
            lessonChange() {
                this.allDialogClose();
                if (!this.multipleSelection.length) {
                    this.$message({
                        showClose: true,
                        message: '错了哦，需要先选中至少一条记录',
                        type: 'error'
                    });
                    return false
                }
                if (this.multipleSelection.length != 1) {
                    this.$message({
                        showClose: true,
                        message: '错了哦，只能选中一条记录',
                        type: 'error'
                    });
                    return false
                }
                let row = this.multipleSelection[0];
                this.form.lesson = row.Recovered;
                this.form.rowName = row.name;
                this.dialogVisible = true;
                this.dialogLesson = true;

            },
            // 赠送调整
            giftChange() {
                this.allDialogClose();
                if (!this.multipleSelection.length) {
                    this.$message({
                        showClose: true,
                        message: '错了哦，需要先选中至少一条记录',
                        type: 'error'
                    });
                    return false
                }
                if (this.multipleSelection.length != 1) {
                    this.$message({
                        showClose: true,
                        message: '错了哦，只能选中一条记录',
                        type: 'error'
                    });
                    return false
                }
                let row = this.multipleSelection[0];
                this.form.gift = row.Recovered;
                this.form.rowName = row.name;
                this.dialogVisible = true;
                this.dialogGift = true;

            },
            // 增删教练课程
            lessonStudenChange() {
                this.allDialogClose();
                if (!this.multipleSelection.length) {
                    this.$message({
                        showClose: true,
                        message: '错了哦，需要先选中至少一条记录',
                        type: 'error'
                    });
                    return false
                }
                if (this.multipleSelection.length != 1) {
                    this.$message({
                        showClose: true,
                        message: '错了哦，只能选中一条记录',
                        type: 'error'
                    });
                    return false
                }
                let row = this.multipleSelection[0];
                this.form.gift = row.Recovered;
                this.form.rowName = row.name;
                this.dialogVisible = true;
                this.dialogLessonTable = true;
            },
            // 确认提交新增教练
            confirmMember() {
                let that = this;
                // checkNum
                if (!that.form.userCode) {
                    this.$message.error('错了哦，手机号不能为空');
                    return false
                }
                if (!globalCheckPhone(that.form.userCode)) {
                    this.$message.error('错了哦，手机号格式不正确');
                    return false
                }
                if (!that.form.name) {
                    this.$message.error('错了哦，教练名不能为空');
                    return false
                }
                if (that.form.name.length > 8) {
                    this.$message.error('错了哦，教练名字数超过8个字');
                    return false
                }
                if (that.form.memo) {
                    if (that.form.memo.length > 200) {
                        this.$message.error('错了哦，备注字数超过200个字');
                        return false
                    }
                }

                let param = {
                    token: localStorage.token,
                    userCode: that.form.userCode,
                    name: that.form.name,
                    memberType: that.form.memberType,
                    lesson: that.form.lesson,
                    gift: that.form.gift,
                    memo: that.form.memo,
                    dialogValue: that.form.dialogValue,
                };
                let postdata = qs.stringify(param);
                testSelect(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        // 关闭弹窗
                        that.dialogMemberVisible = false;
                        // 重载列表
                        that.getTableQuery();
                        that.$message({
                            showClose: true,
                            message: '教练添加成功！',
                            type: 'success'
                        });
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            confirmEditMember() {
                console.log(123);
                let that = this;
                // checkNum
                if (!that.form.userCode) {
                    this.$message.error('错了哦，手机号不能为空');
                    return false
                }
                console.log(that.form.userCode);
                if (!globalCheckPhone(that.form.userCode)) {
                    this.$message.error('错了哦，手机号格式不正确');
                    return false
                }
                if (!that.form.name) {
                    this.$message.error('错了哦，教练名不能为空');
                    return false
                }
                if (that.form.name.length > 8) {
                    this.$message.error('错了哦，教练名字数超过8个字');
                    return false
                }
                if (that.form.memo) {
                    if (that.form.memo.length > 200) {
                        this.$message.error('错了哦，备注字数超过200个字');
                        return false
                    }
                }
                let param = {
                    token: localStorage.token,
                    userCode: that.form.userCode,
                    name: that.form.name,
                    memberType: that.form.memberType,
                    lesson: that.form.lesson,
                    gift: that.form.gift,
                    memo: that.form.memo,
                    dialogValue: that.form.dialogValue,
                };
                let postdata = qs.stringify(param);
                testSelect(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        // 关闭弹窗
                        that.dialogMemberVisible = false;
                        // 重载列表
                        that.getTableQuery();
                        that.$message({
                            showClose: true,
                            message: '教练信息编辑成功！',
                            type: 'success'
                        });
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            // 确认提交课时
            confirmLesson() {
                let that = this;
                // checkNum

                let param = {
                    token: localStorage.token,
                    userCode: that.form.userCode,
                    lesson: that.form.lesson,
                };
                let postdata = qs.stringify(param);
                testSelect(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        // 关闭弹窗
                        that.dialogVisible = false;
                        // 重载列表
                        that.getTableQuery();
                        that.$message({
                            showClose: true,
                            message: '课时调整成功！',
                            type: 'success'
                        });
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            // 确认提交赠送
            confirmGift() {
                let that = this;
                // checkNum

                let param = {
                    token: localStorage.token,
                    userCode: that.form.userCode,
                    gift: that.form.gift,
                };
                let postdata = qs.stringify(param);
                testSelect(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        // 关闭弹窗
                        that.dialogVisible = false;
                        // 重载列表
                        that.getTableQuery();
                        that.$message({
                            showClose: true,
                            message: '赠送课时调整成功！',
                            type: 'success'
                        });
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            // 确认提交有效期
            confirmExpTime() {
                let that = this;
                // checkNum

                let param = {
                    token: localStorage.token,
                    userCode: that.form.userCode,
                    expTime: that.form.expTime,
                };
                let postdata = qs.stringify(param);
                testSelect(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        // 关闭弹窗
                        that.dialogVisible = false;
                        // 重载列表
                        that.getTableQuery();
                        that.$message({
                            showClose: true,
                            message: '赠送课时调整成功！',
                            type: 'success'
                        });
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            // 确认提交教练课程
            confirmLessonTable() {
                let that = this;
                // checkNum

                let param = {
                    token: localStorage.token,
                    userCode: that.form.userCode,
                    dialogValue: that.form.dialogValue,
                };
                let postdata = qs.stringify(param);
                testSelect(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        // 关闭弹窗
                        that.dialogVisible = false;
                        // 重载列表
                        that.getTableQuery();
                        that.$message({
                            showClose: true,
                            message: '教练课程调整成功！',
                            type: 'success'
                        });
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            // 加载选项
            panelSelect() {
                let that = this;
                let param = {
                    token: localStorage.token,
                };
                let postdata = qs.stringify(param);
                testSelect(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        that.form.dialogdata = json.Rs;
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            // 新增教练
            addMember() {
                this.clearForm();
                this.dialogMemberVisible = true
                this.btnType = 0;
                this.dialogTitle = '新增教练'
            },
            // 删除
            delList() {
                let that = this;
                // checkNum
                if (!this.multipleSelection.length) {
                    that.$message({
                        showClose: true,
                        message: '错了哦，需要先选中至少一条记录',
                        type: 'error'
                    });
                    return false
                }
                if (this.multipleSelection.length != 1) {
                    that.$message({
                        showClose: true,
                        message: '错了哦，只能选中一条记录',
                        type: 'error'
                    });
                    return false
                }

                let detectorid = that.multipleSelection[0].Id;

                let param = {
                    token: localStorage.token,
                    detectorid: detectorid,
                    status: 9,//0禁用1启用9删除
                };
                let postdata = qs.stringify(param);

                this.$confirm('此操作将永久删除该教练, 是否继续?', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: 'warning'
                }).then(() => {
                    testSelect(postdata).then(res => {
                        let json = res;
                        if (json.Code == 0) {
                            that.$message({
                                showClose: true,
                                message: '选中的教练已删除！',
                                type: 'success'
                            });
                            // 重载列表
                            that.getTableQuery();
                        } else {
                            that.$message.error(json.Memo);
                        }
                    });
                }).catch(() => {
                    this.$message({
                        type: 'info',
                        message: '已取消删除'
                    });
                });
            },

            handleSelectionChange(val) {
                this.multipleSelection = val;
            },
            // 查询按钮
            query() {
                // this.getTableQuery();
                this.$message.success('查询完毕');
            },
            clearForm() {
                // clear
                this.form.name = '';
                this.form.userCode = '';
                this.form.shopId = '';
            },
            // 页面数据查询
            getTableQuery() {
                let that = this;
                // this.getGetChildRegionSelect(0, 1);
                that.loading = true;
                // 查询检测设备。上级区域id，区域id必传。regionid传0，查询supregionid对应所有子区域的检测设备。 如果supregionid，regionid都传0，默认查询企业ID下所有检测设备
                let param = {
                    token: localStorage.token,
                    supregionid: 0,//
                    regionid: this.panel.regionid,//
                    comid: 1,//
                    tagname: that.panel.tagname,//标签名
                    start: 1,//
                    tableMax: 9999,//
                };
                let postdata = qs.stringify(param);
                testTable(postdata).then(res => {
                    let json = res;
                    if (json.Code == 0) {
                        that.loading = false;
                        if (json.Rs) {
                            that.allTableData = json.Rs;
                            that.recordsTotal = json.Rs.length;
                        } else {
                            that.allTableData = [];
                            that.recordsTotal = 0;
                        }

                        // 设置分页数据
                        that.setPaginations();
                    } else {
                        that.$message.error(json.Memo);
                    }
                })
            },
            // 导出excel
            btnExpAll() {
                let that = this;
                let url = headapi + '?ctl=ajax&mod=czgl&act=czcx_excel';//获取
                let bt = globaltime2String(that.panel.time1[0]);
                let et = globaltime2String(that.panel.time1[1]);
                let usercode = that.panel.usercode;
                window.location = url + '&bt=' + bt + '&et=' + et + '&usercode=' + usercode;
            },
            // 设置分页数据
            setPaginations() {
                // 分页属性
                let that = this;
                that.pageination.total = that.recordsTotal;

                // 默认分页
                that.tableData = that.allTableData.filter((item, index) => {
                    return index < that.pageination.pageItem;
                });
            },
            // 每页显示数量
            handleSizeChange() {
                let that = this;
                that.tableData = that.allTableData.filter((item, index) => {
                    return index < that.pageination.pageItem;
                });
                that.draw = that.pageination.pageItem;
                that.getTableQuery();
            },
            // 翻页
            pageChange(pageIndex) {
                let that = this;
                // 获取当前页
                let index = that.pageination.pageItem * (pageIndex - 1);
                // 数据总数
                let nums = that.pageination.pageItem * pageIndex;
                // 容器
                let tables = [];
                for (var i = index; i < nums; i++) {
                    if (that.allTableData[i]) {
                        tables.push(that.allTableData[i])
                    }
                    this.tableData = tables;
                }
                that.start = index * that.draw;
                that.getTableQuery();
            },
            // 自动排序
            sortChange(params) {
                console.log(params)
            },
            // 过滤时间
            filterFmtDate(value, row, column) {
                let that = this;
                return nonTfmtDate(column, 11);
            },
            // 过滤金额
            filterMoney(value, row, column) {
                let that = this;
                return parseFloat(column).toFixed(2);
            },
        },
    }
</script>

<style scoped>
    @import "../assets/css/panel.css";

    .context {
        overflow: hidden;
        display: block;
        margin: 0 auto;
        background-color: #fff !important;
        padding: 30px;
    }

    .panel-body {
        padding: 20px;
        background: #F0F2F5;
    }

    .change {
        width: 100%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        padding-top: 10px;
        padding-bottom: 10px;
    }

    .change button {
        float: left;
    }

    .change button.pull-right {
        float: right;
    }

    .dialogTitle {
        width: 100%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        color: #000000;
        font-size: 18px;
        text-align: center;
    }

    .dialogTitle em {
        float: none;
        font-style: normal;
        color: #3799FF;
        margin: 0;
    }

    /deep/ .el-transfer-panel__item .el-checkbox__input {
        left: 40px;
    }

    .dialogFooter {
        width: 90%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
        margin-top: 10px;
    }

    .dialogFooter button {
        float: right;
        margin-left: 10px;
    }

    .dialogContent {
        width: 100%;
        overflow: hidden;
        display: block;
        margin: 0 auto;
    }

    .dialogContent .pull-left {
        width: 30%;
        float: left;
    }

    .dialogContent .pull-right {
        width: 70%;
        float: right;
    }
</style>
